﻿using System.Collections.Generic;
using Libs;
using System;
namespace NullObject.Ejm1
{
    /// <summary>
    /// Fabrica de objetos
    /// </summary>
    class LoggerFactory
    {
        /// <summary>
        /// Determina si el parámetro de configuración FileLogging=ON
        /// </summary>
        /// <returns>True si está en ON, false si esta en OFF</returns>
        public bool IsFileLogginEnabled()
        {
            Dictionary<string, string> properties = Properties.GetProperties(@"d:\logger.properties");
            if (properties["FileLogging"].Equals("ON"))
                return true;
            else
                return false;
        }

        /**
         * Factory Method
         * @return un objeto de la jerarquia Logger, incluyendo NullLogger
         */
        public Logger GetLogger()
        {
            Logger logger = null;
            try
            {
                if (IsFileLogginEnabled())
                {
                    logger = new FileLogger();
                }
                else
                {
                    logger = new ConsoleLogger();
                }
            }
            catch (Exception e)
            {
                logger = new NullLogger();//Faltaba esta linea
            }
            return logger;
        }
    }
}
